#include "extern.h"
distribute_loop_forall(node)
Node *node;
{
 Node *astmt = node->ForallStmt.Stmt;
 Node *var, *expr,*expr1;
 T_Entry *entry;
 Node *triplet, *temp, *list;
 int i, distribute_dim,rank;
 Node *block;
 struct S_ForallTripletSpec *trip;
 
 var  = astmt->AssignementStmt.Variable;
 expr = astmt->AssignementStmt.Expr;
 if((entry=lookup_loc(var->com.str))==TN)
                  return 0;
   rank = 0;
   list = list_invert(node->ForallStmt.ForallTripletSpecList);
   for (LIST_LOOP (triplet, list, temp)) rank++;


  if(IS_aligned(entry)) { 
   i=0;
   list = list_invert(node->ForallStmt.ForallTripletSpecList);
   for (LIST_LOOP (triplet, list, temp)){
     trip =  &triplet->ForallTripletSpec;
     i = find_index_in_arraysection(trip->Name, var);
    if(entry->local_shape->distr_dim[i]!= -1) {
      /*
  if(expr->com.type==NAME) 
          astmt->AssignementStmt.Expr= local_to_global(expr,entry->local_shape->distr_dim[i]);
       else
        change_forall_index(expr,trip->Name, entry->local_shape->distr_dim[i]);
      */

       if(tree_eq(trip->Expr, entry->typ->shape->sizes0[i])
          && tree_eq(trip->Expr1, entry->typ->shape->sizes1[i])){
          trip->Expr =
                      tree_dup(trip->Expr); 
          trip->Expr1 =         
                      tree_dup(trip->Expr1);
          trip->Expr = entry->local_shape->sizes0[i];     
          trip->Expr1= entry->local_shape->sizes1[i];     
        }
        else
        { /* make a call statement add it before root */
          llb_num_index_set(rank);
          lub_num_index_set(rank);
          distribute_dim = entry->local_shape->distr_dim[i];
          if(distribute_dim == 0)
            block = block0;
          else 
            block = block1;
          call_adjust_local_bounds(node,
               trip->Expr,
               trip->Expr1,i,
               distribute_dim, block);
               trip->Expr = llb_index(i);
               trip->Expr1 = lub_index(i);
       
       }
     }
   i++;

   }
 }
  }

int find_index_in_arraysection(Name, var)
Node *Name, *var;
{
 int position;
 Node *sub, *temp;
 position =0;
 for (LIST_LOOP ( sub, list_invert(var->ArraySection.SubscriptList), temp)){
   if (tree_eq(sub->Subscript.Expr, Name))
                          return position;
   position++;
}
}

call_adjust_local_bounds(root, input1,input2,i,distribute_dim, block)
Node *root, *input1, *input2;
Node *block;
int i, distribute_dim;
{
  Node *valum[7];
  Node *Name, *sublist, *stmt;
  Node *output1, *output2;
  T_Entry *entry;
  if(!(entry=lookup_glo("adjust_local_bounds")) )
       entry = install_glo("adjust_local_bounds", TAB_NAME, 0);
  Name=make_Name("adjust_local_bounds"); 


  valum[0] = make_Subscript(input1, NN, NN);
  valum[1] = make_Subscript(input2, NN, NN);
  output1=llb_index(i);
  output1->com.typ = typ_malloc();
  output1->com.typ->etype = Etype_CHARACTER_0;
  valum[2] = make_Subscript(output1, NN, NN);

  output2=lub_index(i);
  output2->com.typ = typ_malloc();
  output2->com.typ->etype = Etype_CHARACTER_0;
  valum[3] = make_Subscript(output2, NN, NN);
  valum[4] = make_Subscript (make_IntegerConstant (distribute_dim+1), NN, NN);
  valum[5] = make_Subscript(block, NN, NN);
  sublist = make_List (valum,6 , SUBSCRIPT_LIST);
                 stmt=make_CallStmt(Name,sublist);
               root->com.trans = trans_add_stmt_bef(root->com.trans, stmt);

}

/*  
   This routine is to make index which is distributed global again.
    forall(i=1:N) a(i)=i
   when iteration disatributed such as forall(i=1:25) for 4 processors
   which you learn this info from index_dist[7] global data structure
   also thre are same small routine to access this data structure easliy
*/   

make_global_dist_index(root)
Node *root;
{

 Node *tripletspec;
 struct S_ForallTripletSpec *triplet;
 Node *astmt = root->ForallStmt.Stmt;
 Node *temp;
 int dim;

 for(LIST_LOOP (tripletspec, root->ForallStmt.ForallTripletSpecList, temp)) {
     triplet= &tripletspec->ForallTripletSpec;
     if(dist( triplet->Name)== 1) {
                    dim =idim(triplet->Name);
                    astmt->AssignementStmt.Expr = dist_index_in_expr_to_global(
                       astmt->AssignementStmt.Expr, triplet->Name, dim);
		  }
   }
}


Node *dist_index_in_expr_to_global(expr, Name, ddim)
Node *expr, *Name;
int ddim;
{
  int i;
  Node *child;
  Node *expr1;
  
  if(expr==NN)
       return expr;

  if(expr->com.type==NAME) 
                if (!U_strcmp_nocase(expr->com.str,Name->com.str)) {
                     expr = local_to_global(expr,ddim);
                     return expr;
		   }
  for(i=0; i< node_nodes(expr->com.type); i++) {
    if((child = expr->com.node [i]) != NN && child->com.type ==NAME ) {
                if (!U_strcmp_nocase(child->com.str,Name->com.str)) {
                     expr->com.node[i] = local_to_global(child,ddim);
                   }
     }
     if(child != NN && child->com.type != SUBSCRIPT)
       child =  dist_index_in_expr_to_global(child, Name, ddim);
  }
  return expr;
}

/* This routine is need for PARTI, since some of loop indexies are distribute.
   It has to be converted into global because later you can conver local
   and proc_id from global
   For example, for(i=1:100) a(i)=b(i+8)
                for(i=1:25) 
   global_to_local(i) + 8 is global index from that 
         you can calculate global_to_local (   global_to_local(i) + 8 ) and
                           global_to_local (   global_to_local(i) + 8 ) 
   since 8 is not distributed but i is
*/

make_sub_global(ele,root)
Node *ele, *root;
{
 Node *temp, *sub, *temp1;
 Node *tripletspec;
 struct S_ForallTripletSpec *triplet;
 int dim;

 for(LIST_LOOP(sub, list_invert(ele->ArraySection.SubscriptList),temp)) {
 for(LIST_LOOP (tripletspec, root->ForallStmt.ForallTripletSpecList, temp1)) {
     triplet= &tripletspec->ForallTripletSpec;
     if(dist( triplet->Name)== 1) {
                    dim =idim(triplet->Name);
                         sub->Subscript.Expr  = dist_index_in_sub_to_global(
                            sub->Subscript.Expr, triplet->Name, dim);
		  }
   }
}
}



Node *dist_index_in_sub_to_global(expr, Name, ddim)
Node *expr, *Name;
int ddim;
{
  int i;
  Node *child;
  Node *expr1;
  
  if(expr==NN)
       return expr;

  if(expr->com.type==NAME) 
       if (!U_strcmp_nocase(expr->com.str,Name->com.str)) {
               expr = local_to_global(expr,ddim);
               return expr;
	     }
  for(i=0; i< node_nodes(expr->com.type); i++) {
    if((child = expr->com.node [i]) != NN && child->com.type ==NAME ) {
                if (!U_strcmp_nocase (child->com.str,Name->com.str)) {
                     expr->com.node[i] = local_to_global(child,ddim);
                   }
     }
     if(child != NN )
       child =  dist_index_in_sub_to_global(child, Name, ddim);
  }
  return expr;
}
